# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['AppSecByPassNetworkListArgs', 'AppSecByPassNetworkList']

@pulumi.input_type
class AppSecByPassNetworkListArgs:
    def __init__(__self__, *,
                 bypass_network_lists: pulumi.Input[Sequence[pulumi.Input[str]]],
                 config_id: pulumi.Input[int],
                 version: pulumi.Input[int]):
        """
        The set of arguments for constructing a AppSecByPassNetworkList resource.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] bypass_network_lists: A list containing the IDs of the network lists to use.
        :param pulumi.Input[int] config_id: The configuration ID to use.
        :param pulumi.Input[int] version: The version number of the configuration to use.
        """
        pulumi.set(__self__, "bypass_network_lists", bypass_network_lists)
        pulumi.set(__self__, "config_id", config_id)
        pulumi.set(__self__, "version", version)

    @property
    @pulumi.getter(name="bypassNetworkLists")
    def bypass_network_lists(self) -> pulumi.Input[Sequence[pulumi.Input[str]]]:
        """
        A list containing the IDs of the network lists to use.
        """
        return pulumi.get(self, "bypass_network_lists")

    @bypass_network_lists.setter
    def bypass_network_lists(self, value: pulumi.Input[Sequence[pulumi.Input[str]]]):
        pulumi.set(self, "bypass_network_lists", value)

    @property
    @pulumi.getter(name="configId")
    def config_id(self) -> pulumi.Input[int]:
        """
        The configuration ID to use.
        """
        return pulumi.get(self, "config_id")

    @config_id.setter
    def config_id(self, value: pulumi.Input[int]):
        pulumi.set(self, "config_id", value)

    @property
    @pulumi.getter
    def version(self) -> pulumi.Input[int]:
        """
        The version number of the configuration to use.
        """
        return pulumi.get(self, "version")

    @version.setter
    def version(self, value: pulumi.Input[int]):
        pulumi.set(self, "version", value)


@pulumi.input_type
class _AppSecByPassNetworkListState:
    def __init__(__self__, *,
                 bypass_network_lists: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 config_id: Optional[pulumi.Input[int]] = None,
                 version: Optional[pulumi.Input[int]] = None):
        """
        Input properties used for looking up and filtering AppSecByPassNetworkList resources.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] bypass_network_lists: A list containing the IDs of the network lists to use.
        :param pulumi.Input[int] config_id: The configuration ID to use.
        :param pulumi.Input[int] version: The version number of the configuration to use.
        """
        if bypass_network_lists is not None:
            pulumi.set(__self__, "bypass_network_lists", bypass_network_lists)
        if config_id is not None:
            pulumi.set(__self__, "config_id", config_id)
        if version is not None:
            pulumi.set(__self__, "version", version)

    @property
    @pulumi.getter(name="bypassNetworkLists")
    def bypass_network_lists(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        A list containing the IDs of the network lists to use.
        """
        return pulumi.get(self, "bypass_network_lists")

    @bypass_network_lists.setter
    def bypass_network_lists(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "bypass_network_lists", value)

    @property
    @pulumi.getter(name="configId")
    def config_id(self) -> Optional[pulumi.Input[int]]:
        """
        The configuration ID to use.
        """
        return pulumi.get(self, "config_id")

    @config_id.setter
    def config_id(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "config_id", value)

    @property
    @pulumi.getter
    def version(self) -> Optional[pulumi.Input[int]]:
        """
        The version number of the configuration to use.
        """
        return pulumi.get(self, "version")

    @version.setter
    def version(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "version", value)


class AppSecByPassNetworkList(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 bypass_network_lists: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 config_id: Optional[pulumi.Input[int]] = None,
                 version: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        """
        Use the `AppSecByPassNetworkList` resource to update which network lists to use in the
        bypass network lists settings. Note: this resource is only applicable to WAP (Web Application
        Protector) configurations.

        ## Example Usage

        Basic usage:

        ```python
        import pulumi
        import pulumi_akamai as akamai

        configuration = akamai.get_app_sec_configuration(name=var["security_configuration"])
        bypass_network_lists = akamai.AppSecByPassNetworkList("bypassNetworkLists",
            config_id=configuration.config_id,
            version=configuration.latest_version,
            bypass_network_lists=[
                "id1",
                "id2",
            ])
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] bypass_network_lists: A list containing the IDs of the network lists to use.
        :param pulumi.Input[int] config_id: The configuration ID to use.
        :param pulumi.Input[int] version: The version number of the configuration to use.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: AppSecByPassNetworkListArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Use the `AppSecByPassNetworkList` resource to update which network lists to use in the
        bypass network lists settings. Note: this resource is only applicable to WAP (Web Application
        Protector) configurations.

        ## Example Usage

        Basic usage:

        ```python
        import pulumi
        import pulumi_akamai as akamai

        configuration = akamai.get_app_sec_configuration(name=var["security_configuration"])
        bypass_network_lists = akamai.AppSecByPassNetworkList("bypassNetworkLists",
            config_id=configuration.config_id,
            version=configuration.latest_version,
            bypass_network_lists=[
                "id1",
                "id2",
            ])
        ```

        :param str resource_name: The name of the resource.
        :param AppSecByPassNetworkListArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(AppSecByPassNetworkListArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 bypass_network_lists: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 config_id: Optional[pulumi.Input[int]] = None,
                 version: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = AppSecByPassNetworkListArgs.__new__(AppSecByPassNetworkListArgs)

            if bypass_network_lists is None and not opts.urn:
                raise TypeError("Missing required property 'bypass_network_lists'")
            __props__.__dict__["bypass_network_lists"] = bypass_network_lists
            if config_id is None and not opts.urn:
                raise TypeError("Missing required property 'config_id'")
            __props__.__dict__["config_id"] = config_id
            if version is None and not opts.urn:
                raise TypeError("Missing required property 'version'")
            __props__.__dict__["version"] = version
        super(AppSecByPassNetworkList, __self__).__init__(
            'akamai:index/appSecByPassNetworkList:AppSecByPassNetworkList',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            bypass_network_lists: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            config_id: Optional[pulumi.Input[int]] = None,
            version: Optional[pulumi.Input[int]] = None) -> 'AppSecByPassNetworkList':
        """
        Get an existing AppSecByPassNetworkList resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] bypass_network_lists: A list containing the IDs of the network lists to use.
        :param pulumi.Input[int] config_id: The configuration ID to use.
        :param pulumi.Input[int] version: The version number of the configuration to use.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _AppSecByPassNetworkListState.__new__(_AppSecByPassNetworkListState)

        __props__.__dict__["bypass_network_lists"] = bypass_network_lists
        __props__.__dict__["config_id"] = config_id
        __props__.__dict__["version"] = version
        return AppSecByPassNetworkList(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="bypassNetworkLists")
    def bypass_network_lists(self) -> pulumi.Output[Sequence[str]]:
        """
        A list containing the IDs of the network lists to use.
        """
        return pulumi.get(self, "bypass_network_lists")

    @property
    @pulumi.getter(name="configId")
    def config_id(self) -> pulumi.Output[int]:
        """
        The configuration ID to use.
        """
        return pulumi.get(self, "config_id")

    @property
    @pulumi.getter
    def version(self) -> pulumi.Output[int]:
        """
        The version number of the configuration to use.
        """
        return pulumi.get(self, "version")

