# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['AppSecConfigurationCloneArgs', 'AppSecConfigurationClone']

@pulumi.input_type
class AppSecConfigurationCloneArgs:
    def __init__(__self__, *,
                 contract_id: pulumi.Input[str],
                 create_from_config_id: pulumi.Input[int],
                 create_from_version: pulumi.Input[int],
                 description: pulumi.Input[str],
                 group_id: pulumi.Input[int],
                 host_names: pulumi.Input[Sequence[pulumi.Input[str]]],
                 name: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a AppSecConfigurationClone resource.
        :param pulumi.Input[str] contract_id: The contract id to use.
        :param pulumi.Input[int] create_from_config_id: The ID of the configuration to be cloned.
        :param pulumi.Input[int] create_from_version: The version number of the configuration to be cloned.
        :param pulumi.Input[str] description: A description of the new configuration.
        :param pulumi.Input[int] group_id: The group id to use.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] host_names: The hostnames to be protected under the new configuration.
        :param pulumi.Input[str] name: The name to be applied to the new configuration.
        """
        pulumi.set(__self__, "contract_id", contract_id)
        pulumi.set(__self__, "create_from_config_id", create_from_config_id)
        pulumi.set(__self__, "create_from_version", create_from_version)
        pulumi.set(__self__, "description", description)
        pulumi.set(__self__, "group_id", group_id)
        pulumi.set(__self__, "host_names", host_names)
        if name is not None:
            pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter(name="contractId")
    def contract_id(self) -> pulumi.Input[str]:
        """
        The contract id to use.
        """
        return pulumi.get(self, "contract_id")

    @contract_id.setter
    def contract_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "contract_id", value)

    @property
    @pulumi.getter(name="createFromConfigId")
    def create_from_config_id(self) -> pulumi.Input[int]:
        """
        The ID of the configuration to be cloned.
        """
        return pulumi.get(self, "create_from_config_id")

    @create_from_config_id.setter
    def create_from_config_id(self, value: pulumi.Input[int]):
        pulumi.set(self, "create_from_config_id", value)

    @property
    @pulumi.getter(name="createFromVersion")
    def create_from_version(self) -> pulumi.Input[int]:
        """
        The version number of the configuration to be cloned.
        """
        return pulumi.get(self, "create_from_version")

    @create_from_version.setter
    def create_from_version(self, value: pulumi.Input[int]):
        pulumi.set(self, "create_from_version", value)

    @property
    @pulumi.getter
    def description(self) -> pulumi.Input[str]:
        """
        A description of the new configuration.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: pulumi.Input[str]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="groupId")
    def group_id(self) -> pulumi.Input[int]:
        """
        The group id to use.
        """
        return pulumi.get(self, "group_id")

    @group_id.setter
    def group_id(self, value: pulumi.Input[int]):
        pulumi.set(self, "group_id", value)

    @property
    @pulumi.getter(name="hostNames")
    def host_names(self) -> pulumi.Input[Sequence[pulumi.Input[str]]]:
        """
        The hostnames to be protected under the new configuration.
        """
        return pulumi.get(self, "host_names")

    @host_names.setter
    def host_names(self, value: pulumi.Input[Sequence[pulumi.Input[str]]]):
        pulumi.set(self, "host_names", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        The name to be applied to the new configuration.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)


@pulumi.input_type
class _AppSecConfigurationCloneState:
    def __init__(__self__, *,
                 config_id: Optional[pulumi.Input[int]] = None,
                 contract_id: Optional[pulumi.Input[str]] = None,
                 create_from_config_id: Optional[pulumi.Input[int]] = None,
                 create_from_version: Optional[pulumi.Input[int]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 group_id: Optional[pulumi.Input[int]] = None,
                 host_names: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 version: Optional[pulumi.Input[int]] = None):
        """
        Input properties used for looking up and filtering AppSecConfigurationClone resources.
        :param pulumi.Input[int] config_id: The ID of the newly created configuration.
        :param pulumi.Input[str] contract_id: The contract id to use.
        :param pulumi.Input[int] create_from_config_id: The ID of the configuration to be cloned.
        :param pulumi.Input[int] create_from_version: The version number of the configuration to be cloned.
        :param pulumi.Input[str] description: A description of the new configuration.
        :param pulumi.Input[int] group_id: The group id to use.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] host_names: The hostnames to be protected under the new configuration.
        :param pulumi.Input[str] name: The name to be applied to the new configuration.
        :param pulumi.Input[int] version: The version number of the newly created configuration.
        """
        if config_id is not None:
            pulumi.set(__self__, "config_id", config_id)
        if contract_id is not None:
            pulumi.set(__self__, "contract_id", contract_id)
        if create_from_config_id is not None:
            pulumi.set(__self__, "create_from_config_id", create_from_config_id)
        if create_from_version is not None:
            pulumi.set(__self__, "create_from_version", create_from_version)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if group_id is not None:
            pulumi.set(__self__, "group_id", group_id)
        if host_names is not None:
            pulumi.set(__self__, "host_names", host_names)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if version is not None:
            pulumi.set(__self__, "version", version)

    @property
    @pulumi.getter(name="configId")
    def config_id(self) -> Optional[pulumi.Input[int]]:
        """
        The ID of the newly created configuration.
        """
        return pulumi.get(self, "config_id")

    @config_id.setter
    def config_id(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "config_id", value)

    @property
    @pulumi.getter(name="contractId")
    def contract_id(self) -> Optional[pulumi.Input[str]]:
        """
        The contract id to use.
        """
        return pulumi.get(self, "contract_id")

    @contract_id.setter
    def contract_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "contract_id", value)

    @property
    @pulumi.getter(name="createFromConfigId")
    def create_from_config_id(self) -> Optional[pulumi.Input[int]]:
        """
        The ID of the configuration to be cloned.
        """
        return pulumi.get(self, "create_from_config_id")

    @create_from_config_id.setter
    def create_from_config_id(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "create_from_config_id", value)

    @property
    @pulumi.getter(name="createFromVersion")
    def create_from_version(self) -> Optional[pulumi.Input[int]]:
        """
        The version number of the configuration to be cloned.
        """
        return pulumi.get(self, "create_from_version")

    @create_from_version.setter
    def create_from_version(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "create_from_version", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        A description of the new configuration.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="groupId")
    def group_id(self) -> Optional[pulumi.Input[int]]:
        """
        The group id to use.
        """
        return pulumi.get(self, "group_id")

    @group_id.setter
    def group_id(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "group_id", value)

    @property
    @pulumi.getter(name="hostNames")
    def host_names(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The hostnames to be protected under the new configuration.
        """
        return pulumi.get(self, "host_names")

    @host_names.setter
    def host_names(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "host_names", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        The name to be applied to the new configuration.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def version(self) -> Optional[pulumi.Input[int]]:
        """
        The version number of the newly created configuration.
        """
        return pulumi.get(self, "version")

    @version.setter
    def version(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "version", value)


class AppSecConfigurationClone(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 contract_id: Optional[pulumi.Input[str]] = None,
                 create_from_config_id: Optional[pulumi.Input[int]] = None,
                 create_from_version: Optional[pulumi.Input[int]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 group_id: Optional[pulumi.Input[int]] = None,
                 host_names: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        The `resource_akamai_appsec_configuration_clone` resource allows you to create a new version of a given security configuration.

        ## Example Usage

        Basic usage:

        ```python
        import pulumi
        import pulumi_akamai as akamai

        configuration = akamai.get_app_sec_configuration(name=var["security_configuration"])
        contracts_groups = akamai.get_app_sec_contracts_groups(contractid=var["contractid"],
            groupid=var["groupid"])
        selectable_hostnames = akamai.get_app_sec_selectable_hostnames(config_id=configuration.config_id,
            version=configuration.latest_version)
        clone_config = akamai.AppSecConfigurationClone("cloneConfig",
            create_from_config_id=configuration.config_id,
            create_from_version=configuration.latest_version,
            description=var["description"],
            contract_id=contracts_groups.default_contractid,
            group_id=contracts_groups.default_groupid,
            host_names=selectable_hostnames.hostnames)
        pulumi.export("cloneConfigId", clone_config.config_id)
        pulumi.export("cloneConfigVersion", clone_config.version)
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] contract_id: The contract id to use.
        :param pulumi.Input[int] create_from_config_id: The ID of the configuration to be cloned.
        :param pulumi.Input[int] create_from_version: The version number of the configuration to be cloned.
        :param pulumi.Input[str] description: A description of the new configuration.
        :param pulumi.Input[int] group_id: The group id to use.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] host_names: The hostnames to be protected under the new configuration.
        :param pulumi.Input[str] name: The name to be applied to the new configuration.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: AppSecConfigurationCloneArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        The `resource_akamai_appsec_configuration_clone` resource allows you to create a new version of a given security configuration.

        ## Example Usage

        Basic usage:

        ```python
        import pulumi
        import pulumi_akamai as akamai

        configuration = akamai.get_app_sec_configuration(name=var["security_configuration"])
        contracts_groups = akamai.get_app_sec_contracts_groups(contractid=var["contractid"],
            groupid=var["groupid"])
        selectable_hostnames = akamai.get_app_sec_selectable_hostnames(config_id=configuration.config_id,
            version=configuration.latest_version)
        clone_config = akamai.AppSecConfigurationClone("cloneConfig",
            create_from_config_id=configuration.config_id,
            create_from_version=configuration.latest_version,
            description=var["description"],
            contract_id=contracts_groups.default_contractid,
            group_id=contracts_groups.default_groupid,
            host_names=selectable_hostnames.hostnames)
        pulumi.export("cloneConfigId", clone_config.config_id)
        pulumi.export("cloneConfigVersion", clone_config.version)
        ```

        :param str resource_name: The name of the resource.
        :param AppSecConfigurationCloneArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(AppSecConfigurationCloneArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 contract_id: Optional[pulumi.Input[str]] = None,
                 create_from_config_id: Optional[pulumi.Input[int]] = None,
                 create_from_version: Optional[pulumi.Input[int]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 group_id: Optional[pulumi.Input[int]] = None,
                 host_names: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = AppSecConfigurationCloneArgs.__new__(AppSecConfigurationCloneArgs)

            if contract_id is None and not opts.urn:
                raise TypeError("Missing required property 'contract_id'")
            __props__.__dict__["contract_id"] = contract_id
            if create_from_config_id is None and not opts.urn:
                raise TypeError("Missing required property 'create_from_config_id'")
            __props__.__dict__["create_from_config_id"] = create_from_config_id
            if create_from_version is None and not opts.urn:
                raise TypeError("Missing required property 'create_from_version'")
            __props__.__dict__["create_from_version"] = create_from_version
            if description is None and not opts.urn:
                raise TypeError("Missing required property 'description'")
            __props__.__dict__["description"] = description
            if group_id is None and not opts.urn:
                raise TypeError("Missing required property 'group_id'")
            __props__.__dict__["group_id"] = group_id
            if host_names is None and not opts.urn:
                raise TypeError("Missing required property 'host_names'")
            __props__.__dict__["host_names"] = host_names
            __props__.__dict__["name"] = name
            __props__.__dict__["config_id"] = None
            __props__.__dict__["version"] = None
        super(AppSecConfigurationClone, __self__).__init__(
            'akamai:index/appSecConfigurationClone:AppSecConfigurationClone',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            config_id: Optional[pulumi.Input[int]] = None,
            contract_id: Optional[pulumi.Input[str]] = None,
            create_from_config_id: Optional[pulumi.Input[int]] = None,
            create_from_version: Optional[pulumi.Input[int]] = None,
            description: Optional[pulumi.Input[str]] = None,
            group_id: Optional[pulumi.Input[int]] = None,
            host_names: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            name: Optional[pulumi.Input[str]] = None,
            version: Optional[pulumi.Input[int]] = None) -> 'AppSecConfigurationClone':
        """
        Get an existing AppSecConfigurationClone resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[int] config_id: The ID of the newly created configuration.
        :param pulumi.Input[str] contract_id: The contract id to use.
        :param pulumi.Input[int] create_from_config_id: The ID of the configuration to be cloned.
        :param pulumi.Input[int] create_from_version: The version number of the configuration to be cloned.
        :param pulumi.Input[str] description: A description of the new configuration.
        :param pulumi.Input[int] group_id: The group id to use.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] host_names: The hostnames to be protected under the new configuration.
        :param pulumi.Input[str] name: The name to be applied to the new configuration.
        :param pulumi.Input[int] version: The version number of the newly created configuration.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _AppSecConfigurationCloneState.__new__(_AppSecConfigurationCloneState)

        __props__.__dict__["config_id"] = config_id
        __props__.__dict__["contract_id"] = contract_id
        __props__.__dict__["create_from_config_id"] = create_from_config_id
        __props__.__dict__["create_from_version"] = create_from_version
        __props__.__dict__["description"] = description
        __props__.__dict__["group_id"] = group_id
        __props__.__dict__["host_names"] = host_names
        __props__.__dict__["name"] = name
        __props__.__dict__["version"] = version
        return AppSecConfigurationClone(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="configId")
    def config_id(self) -> pulumi.Output[int]:
        """
        The ID of the newly created configuration.
        """
        return pulumi.get(self, "config_id")

    @property
    @pulumi.getter(name="contractId")
    def contract_id(self) -> pulumi.Output[str]:
        """
        The contract id to use.
        """
        return pulumi.get(self, "contract_id")

    @property
    @pulumi.getter(name="createFromConfigId")
    def create_from_config_id(self) -> pulumi.Output[int]:
        """
        The ID of the configuration to be cloned.
        """
        return pulumi.get(self, "create_from_config_id")

    @property
    @pulumi.getter(name="createFromVersion")
    def create_from_version(self) -> pulumi.Output[int]:
        """
        The version number of the configuration to be cloned.
        """
        return pulumi.get(self, "create_from_version")

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[str]:
        """
        A description of the new configuration.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="groupId")
    def group_id(self) -> pulumi.Output[int]:
        """
        The group id to use.
        """
        return pulumi.get(self, "group_id")

    @property
    @pulumi.getter(name="hostNames")
    def host_names(self) -> pulumi.Output[Sequence[str]]:
        """
        The hostnames to be protected under the new configuration.
        """
        return pulumi.get(self, "host_names")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        The name to be applied to the new configuration.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def version(self) -> pulumi.Output[int]:
        """
        The version number of the newly created configuration.
        """
        return pulumi.get(self, "version")

