# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['AppSecRatePolicyActionArgs', 'AppSecRatePolicyAction']

@pulumi.input_type
class AppSecRatePolicyActionArgs:
    def __init__(__self__, *,
                 config_id: pulumi.Input[int],
                 ipv4_action: pulumi.Input[str],
                 ipv6_action: pulumi.Input[str],
                 rate_policy_id: pulumi.Input[int],
                 security_policy_id: pulumi.Input[str],
                 version: pulumi.Input[int]):
        """
        The set of arguments for constructing a AppSecRatePolicyAction resource.
        :param pulumi.Input[int] config_id: The ID of the security configuration to use.
        :param pulumi.Input[str] ipv4_action: The ipv4 action to assign to this rate policy, either `alert`, `deny`, `deny_custom_{custom_deny_id}`, or `none`. If the action is none, the rate policy is inactive in the policy.
        :param pulumi.Input[str] ipv6_action: The ipv6 action to assign to this rate policy, either `alert`, `deny`, `deny_custom_{custom_deny_id}`, or `none`. If the action is none, the rate policy is inactive in the policy.
        :param pulumi.Input[int] rate_policy_id: The ID of the rate policy to use.
        :param pulumi.Input[int] version: The version number of the security configuration to use.
        """
        pulumi.set(__self__, "config_id", config_id)
        pulumi.set(__self__, "ipv4_action", ipv4_action)
        pulumi.set(__self__, "ipv6_action", ipv6_action)
        pulumi.set(__self__, "rate_policy_id", rate_policy_id)
        pulumi.set(__self__, "security_policy_id", security_policy_id)
        pulumi.set(__self__, "version", version)

    @property
    @pulumi.getter(name="configId")
    def config_id(self) -> pulumi.Input[int]:
        """
        The ID of the security configuration to use.
        """
        return pulumi.get(self, "config_id")

    @config_id.setter
    def config_id(self, value: pulumi.Input[int]):
        pulumi.set(self, "config_id", value)

    @property
    @pulumi.getter(name="ipv4Action")
    def ipv4_action(self) -> pulumi.Input[str]:
        """
        The ipv4 action to assign to this rate policy, either `alert`, `deny`, `deny_custom_{custom_deny_id}`, or `none`. If the action is none, the rate policy is inactive in the policy.
        """
        return pulumi.get(self, "ipv4_action")

    @ipv4_action.setter
    def ipv4_action(self, value: pulumi.Input[str]):
        pulumi.set(self, "ipv4_action", value)

    @property
    @pulumi.getter(name="ipv6Action")
    def ipv6_action(self) -> pulumi.Input[str]:
        """
        The ipv6 action to assign to this rate policy, either `alert`, `deny`, `deny_custom_{custom_deny_id}`, or `none`. If the action is none, the rate policy is inactive in the policy.
        """
        return pulumi.get(self, "ipv6_action")

    @ipv6_action.setter
    def ipv6_action(self, value: pulumi.Input[str]):
        pulumi.set(self, "ipv6_action", value)

    @property
    @pulumi.getter(name="ratePolicyId")
    def rate_policy_id(self) -> pulumi.Input[int]:
        """
        The ID of the rate policy to use.
        """
        return pulumi.get(self, "rate_policy_id")

    @rate_policy_id.setter
    def rate_policy_id(self, value: pulumi.Input[int]):
        pulumi.set(self, "rate_policy_id", value)

    @property
    @pulumi.getter(name="securityPolicyId")
    def security_policy_id(self) -> pulumi.Input[str]:
        return pulumi.get(self, "security_policy_id")

    @security_policy_id.setter
    def security_policy_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "security_policy_id", value)

    @property
    @pulumi.getter
    def version(self) -> pulumi.Input[int]:
        """
        The version number of the security configuration to use.
        """
        return pulumi.get(self, "version")

    @version.setter
    def version(self, value: pulumi.Input[int]):
        pulumi.set(self, "version", value)


@pulumi.input_type
class _AppSecRatePolicyActionState:
    def __init__(__self__, *,
                 config_id: Optional[pulumi.Input[int]] = None,
                 ipv4_action: Optional[pulumi.Input[str]] = None,
                 ipv6_action: Optional[pulumi.Input[str]] = None,
                 rate_policy_id: Optional[pulumi.Input[int]] = None,
                 security_policy_id: Optional[pulumi.Input[str]] = None,
                 version: Optional[pulumi.Input[int]] = None):
        """
        Input properties used for looking up and filtering AppSecRatePolicyAction resources.
        :param pulumi.Input[int] config_id: The ID of the security configuration to use.
        :param pulumi.Input[str] ipv4_action: The ipv4 action to assign to this rate policy, either `alert`, `deny`, `deny_custom_{custom_deny_id}`, or `none`. If the action is none, the rate policy is inactive in the policy.
        :param pulumi.Input[str] ipv6_action: The ipv6 action to assign to this rate policy, either `alert`, `deny`, `deny_custom_{custom_deny_id}`, or `none`. If the action is none, the rate policy is inactive in the policy.
        :param pulumi.Input[int] rate_policy_id: The ID of the rate policy to use.
        :param pulumi.Input[int] version: The version number of the security configuration to use.
        """
        if config_id is not None:
            pulumi.set(__self__, "config_id", config_id)
        if ipv4_action is not None:
            pulumi.set(__self__, "ipv4_action", ipv4_action)
        if ipv6_action is not None:
            pulumi.set(__self__, "ipv6_action", ipv6_action)
        if rate_policy_id is not None:
            pulumi.set(__self__, "rate_policy_id", rate_policy_id)
        if security_policy_id is not None:
            pulumi.set(__self__, "security_policy_id", security_policy_id)
        if version is not None:
            pulumi.set(__self__, "version", version)

    @property
    @pulumi.getter(name="configId")
    def config_id(self) -> Optional[pulumi.Input[int]]:
        """
        The ID of the security configuration to use.
        """
        return pulumi.get(self, "config_id")

    @config_id.setter
    def config_id(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "config_id", value)

    @property
    @pulumi.getter(name="ipv4Action")
    def ipv4_action(self) -> Optional[pulumi.Input[str]]:
        """
        The ipv4 action to assign to this rate policy, either `alert`, `deny`, `deny_custom_{custom_deny_id}`, or `none`. If the action is none, the rate policy is inactive in the policy.
        """
        return pulumi.get(self, "ipv4_action")

    @ipv4_action.setter
    def ipv4_action(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ipv4_action", value)

    @property
    @pulumi.getter(name="ipv6Action")
    def ipv6_action(self) -> Optional[pulumi.Input[str]]:
        """
        The ipv6 action to assign to this rate policy, either `alert`, `deny`, `deny_custom_{custom_deny_id}`, or `none`. If the action is none, the rate policy is inactive in the policy.
        """
        return pulumi.get(self, "ipv6_action")

    @ipv6_action.setter
    def ipv6_action(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ipv6_action", value)

    @property
    @pulumi.getter(name="ratePolicyId")
    def rate_policy_id(self) -> Optional[pulumi.Input[int]]:
        """
        The ID of the rate policy to use.
        """
        return pulumi.get(self, "rate_policy_id")

    @rate_policy_id.setter
    def rate_policy_id(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "rate_policy_id", value)

    @property
    @pulumi.getter(name="securityPolicyId")
    def security_policy_id(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "security_policy_id")

    @security_policy_id.setter
    def security_policy_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "security_policy_id", value)

    @property
    @pulumi.getter
    def version(self) -> Optional[pulumi.Input[int]]:
        """
        The version number of the security configuration to use.
        """
        return pulumi.get(self, "version")

    @version.setter
    def version(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "version", value)


class AppSecRatePolicyAction(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 config_id: Optional[pulumi.Input[int]] = None,
                 ipv4_action: Optional[pulumi.Input[str]] = None,
                 ipv6_action: Optional[pulumi.Input[str]] = None,
                 rate_policy_id: Optional[pulumi.Input[int]] = None,
                 security_policy_id: Optional[pulumi.Input[str]] = None,
                 version: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        """
        The `resource_akamai_appsec_rate_policy_action` resource allows you to create, modify or delete the actions in a rate policy.

        ## Example Usage

        Basic usage:

        ```python
        import pulumi
        import pulumi_akamai as akamai

        configuration = akamai.get_app_sec_configuration(name=var["security_configuration"])
        appsec_rate_policy = akamai.AppSecRatePolicy("appsecRatePolicy",
            config_id=configuration.config_id,
            version=configuration.latest_version,
            rate_policy=(lambda path: open(path).read())(f"{path['module']}/rate_policy.json"))
        appsec_rate_policy_action = akamai.AppSecRatePolicyAction("appsecRatePolicyAction",
            config_id=configuration.config_id,
            version=configuration.latest_version,
            security_policy_id=var["security_policy_id"],
            rate_policy_id=appsec_rate_policy.rate_policy_id,
            ipv4_action="deny",
            ipv6_action="deny")
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[int] config_id: The ID of the security configuration to use.
        :param pulumi.Input[str] ipv4_action: The ipv4 action to assign to this rate policy, either `alert`, `deny`, `deny_custom_{custom_deny_id}`, or `none`. If the action is none, the rate policy is inactive in the policy.
        :param pulumi.Input[str] ipv6_action: The ipv6 action to assign to this rate policy, either `alert`, `deny`, `deny_custom_{custom_deny_id}`, or `none`. If the action is none, the rate policy is inactive in the policy.
        :param pulumi.Input[int] rate_policy_id: The ID of the rate policy to use.
        :param pulumi.Input[int] version: The version number of the security configuration to use.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: AppSecRatePolicyActionArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        The `resource_akamai_appsec_rate_policy_action` resource allows you to create, modify or delete the actions in a rate policy.

        ## Example Usage

        Basic usage:

        ```python
        import pulumi
        import pulumi_akamai as akamai

        configuration = akamai.get_app_sec_configuration(name=var["security_configuration"])
        appsec_rate_policy = akamai.AppSecRatePolicy("appsecRatePolicy",
            config_id=configuration.config_id,
            version=configuration.latest_version,
            rate_policy=(lambda path: open(path).read())(f"{path['module']}/rate_policy.json"))
        appsec_rate_policy_action = akamai.AppSecRatePolicyAction("appsecRatePolicyAction",
            config_id=configuration.config_id,
            version=configuration.latest_version,
            security_policy_id=var["security_policy_id"],
            rate_policy_id=appsec_rate_policy.rate_policy_id,
            ipv4_action="deny",
            ipv6_action="deny")
        ```

        :param str resource_name: The name of the resource.
        :param AppSecRatePolicyActionArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(AppSecRatePolicyActionArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 config_id: Optional[pulumi.Input[int]] = None,
                 ipv4_action: Optional[pulumi.Input[str]] = None,
                 ipv6_action: Optional[pulumi.Input[str]] = None,
                 rate_policy_id: Optional[pulumi.Input[int]] = None,
                 security_policy_id: Optional[pulumi.Input[str]] = None,
                 version: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = AppSecRatePolicyActionArgs.__new__(AppSecRatePolicyActionArgs)

            if config_id is None and not opts.urn:
                raise TypeError("Missing required property 'config_id'")
            __props__.__dict__["config_id"] = config_id
            if ipv4_action is None and not opts.urn:
                raise TypeError("Missing required property 'ipv4_action'")
            __props__.__dict__["ipv4_action"] = ipv4_action
            if ipv6_action is None and not opts.urn:
                raise TypeError("Missing required property 'ipv6_action'")
            __props__.__dict__["ipv6_action"] = ipv6_action
            if rate_policy_id is None and not opts.urn:
                raise TypeError("Missing required property 'rate_policy_id'")
            __props__.__dict__["rate_policy_id"] = rate_policy_id
            if security_policy_id is None and not opts.urn:
                raise TypeError("Missing required property 'security_policy_id'")
            __props__.__dict__["security_policy_id"] = security_policy_id
            if version is None and not opts.urn:
                raise TypeError("Missing required property 'version'")
            __props__.__dict__["version"] = version
        super(AppSecRatePolicyAction, __self__).__init__(
            'akamai:index/appSecRatePolicyAction:AppSecRatePolicyAction',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            config_id: Optional[pulumi.Input[int]] = None,
            ipv4_action: Optional[pulumi.Input[str]] = None,
            ipv6_action: Optional[pulumi.Input[str]] = None,
            rate_policy_id: Optional[pulumi.Input[int]] = None,
            security_policy_id: Optional[pulumi.Input[str]] = None,
            version: Optional[pulumi.Input[int]] = None) -> 'AppSecRatePolicyAction':
        """
        Get an existing AppSecRatePolicyAction resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[int] config_id: The ID of the security configuration to use.
        :param pulumi.Input[str] ipv4_action: The ipv4 action to assign to this rate policy, either `alert`, `deny`, `deny_custom_{custom_deny_id}`, or `none`. If the action is none, the rate policy is inactive in the policy.
        :param pulumi.Input[str] ipv6_action: The ipv6 action to assign to this rate policy, either `alert`, `deny`, `deny_custom_{custom_deny_id}`, or `none`. If the action is none, the rate policy is inactive in the policy.
        :param pulumi.Input[int] rate_policy_id: The ID of the rate policy to use.
        :param pulumi.Input[int] version: The version number of the security configuration to use.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _AppSecRatePolicyActionState.__new__(_AppSecRatePolicyActionState)

        __props__.__dict__["config_id"] = config_id
        __props__.__dict__["ipv4_action"] = ipv4_action
        __props__.__dict__["ipv6_action"] = ipv6_action
        __props__.__dict__["rate_policy_id"] = rate_policy_id
        __props__.__dict__["security_policy_id"] = security_policy_id
        __props__.__dict__["version"] = version
        return AppSecRatePolicyAction(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="configId")
    def config_id(self) -> pulumi.Output[int]:
        """
        The ID of the security configuration to use.
        """
        return pulumi.get(self, "config_id")

    @property
    @pulumi.getter(name="ipv4Action")
    def ipv4_action(self) -> pulumi.Output[str]:
        """
        The ipv4 action to assign to this rate policy, either `alert`, `deny`, `deny_custom_{custom_deny_id}`, or `none`. If the action is none, the rate policy is inactive in the policy.
        """
        return pulumi.get(self, "ipv4_action")

    @property
    @pulumi.getter(name="ipv6Action")
    def ipv6_action(self) -> pulumi.Output[str]:
        """
        The ipv6 action to assign to this rate policy, either `alert`, `deny`, `deny_custom_{custom_deny_id}`, or `none`. If the action is none, the rate policy is inactive in the policy.
        """
        return pulumi.get(self, "ipv6_action")

    @property
    @pulumi.getter(name="ratePolicyId")
    def rate_policy_id(self) -> pulumi.Output[int]:
        """
        The ID of the rate policy to use.
        """
        return pulumi.get(self, "rate_policy_id")

    @property
    @pulumi.getter(name="securityPolicyId")
    def security_policy_id(self) -> pulumi.Output[str]:
        return pulumi.get(self, "security_policy_id")

    @property
    @pulumi.getter
    def version(self) -> pulumi.Output[int]:
        """
        The version number of the security configuration to use.
        """
        return pulumi.get(self, "version")

