# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['AppSecVersionNodesArgs', 'AppSecVersionNodes']

@pulumi.input_type
class AppSecVersionNodesArgs:
    def __init__(__self__, *,
                 config_id: pulumi.Input[int],
                 version: pulumi.Input[int],
                 version_notes: pulumi.Input[str]):
        """
        The set of arguments for constructing a AppSecVersionNodes resource.
        :param pulumi.Input[int] config_id: The configuration ID to use.
        :param pulumi.Input[int] version: The version number of the configuration to use.
        :param pulumi.Input[str] version_notes: A string containing the version notes to be used.
        """
        pulumi.set(__self__, "config_id", config_id)
        pulumi.set(__self__, "version", version)
        pulumi.set(__self__, "version_notes", version_notes)

    @property
    @pulumi.getter(name="configId")
    def config_id(self) -> pulumi.Input[int]:
        """
        The configuration ID to use.
        """
        return pulumi.get(self, "config_id")

    @config_id.setter
    def config_id(self, value: pulumi.Input[int]):
        pulumi.set(self, "config_id", value)

    @property
    @pulumi.getter
    def version(self) -> pulumi.Input[int]:
        """
        The version number of the configuration to use.
        """
        return pulumi.get(self, "version")

    @version.setter
    def version(self, value: pulumi.Input[int]):
        pulumi.set(self, "version", value)

    @property
    @pulumi.getter(name="versionNotes")
    def version_notes(self) -> pulumi.Input[str]:
        """
        A string containing the version notes to be used.
        """
        return pulumi.get(self, "version_notes")

    @version_notes.setter
    def version_notes(self, value: pulumi.Input[str]):
        pulumi.set(self, "version_notes", value)


@pulumi.input_type
class _AppSecVersionNodesState:
    def __init__(__self__, *,
                 config_id: Optional[pulumi.Input[int]] = None,
                 output_text: Optional[pulumi.Input[str]] = None,
                 version: Optional[pulumi.Input[int]] = None,
                 version_notes: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering AppSecVersionNodes resources.
        :param pulumi.Input[int] config_id: The configuration ID to use.
        :param pulumi.Input[str] output_text: A tabular display showing the updated version notes.
        :param pulumi.Input[int] version: The version number of the configuration to use.
        :param pulumi.Input[str] version_notes: A string containing the version notes to be used.
        """
        if config_id is not None:
            pulumi.set(__self__, "config_id", config_id)
        if output_text is not None:
            pulumi.set(__self__, "output_text", output_text)
        if version is not None:
            pulumi.set(__self__, "version", version)
        if version_notes is not None:
            pulumi.set(__self__, "version_notes", version_notes)

    @property
    @pulumi.getter(name="configId")
    def config_id(self) -> Optional[pulumi.Input[int]]:
        """
        The configuration ID to use.
        """
        return pulumi.get(self, "config_id")

    @config_id.setter
    def config_id(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "config_id", value)

    @property
    @pulumi.getter(name="outputText")
    def output_text(self) -> Optional[pulumi.Input[str]]:
        """
        A tabular display showing the updated version notes.
        """
        return pulumi.get(self, "output_text")

    @output_text.setter
    def output_text(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "output_text", value)

    @property
    @pulumi.getter
    def version(self) -> Optional[pulumi.Input[int]]:
        """
        The version number of the configuration to use.
        """
        return pulumi.get(self, "version")

    @version.setter
    def version(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "version", value)

    @property
    @pulumi.getter(name="versionNotes")
    def version_notes(self) -> Optional[pulumi.Input[str]]:
        """
        A string containing the version notes to be used.
        """
        return pulumi.get(self, "version_notes")

    @version_notes.setter
    def version_notes(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "version_notes", value)


class AppSecVersionNodes(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 config_id: Optional[pulumi.Input[int]] = None,
                 version: Optional[pulumi.Input[int]] = None,
                 version_notes: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Use the `AppSecVersionNodes` resource to update the version notes for a configuration.

        ## Example Usage

        Basic usage:

        ```python
        import pulumi
        import pulumi_akamai as akamai

        configuration = akamai.get_app_sec_configuration(name=var["security_configuration"])
        # USE CASE: user wants to update the version notes of the latest version
        version_notes_app_sec_version_nodes = akamai.AppSecVersionNodes("versionNotesAppSecVersionNodes",
            config_id=configuration.config_id,
            version=configuration.latest_version,
            version_notes=var["version_notes"])
        pulumi.export("versionNotes", version_notes_app_sec_version_nodes.output_text)
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[int] config_id: The configuration ID to use.
        :param pulumi.Input[int] version: The version number of the configuration to use.
        :param pulumi.Input[str] version_notes: A string containing the version notes to be used.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: AppSecVersionNodesArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Use the `AppSecVersionNodes` resource to update the version notes for a configuration.

        ## Example Usage

        Basic usage:

        ```python
        import pulumi
        import pulumi_akamai as akamai

        configuration = akamai.get_app_sec_configuration(name=var["security_configuration"])
        # USE CASE: user wants to update the version notes of the latest version
        version_notes_app_sec_version_nodes = akamai.AppSecVersionNodes("versionNotesAppSecVersionNodes",
            config_id=configuration.config_id,
            version=configuration.latest_version,
            version_notes=var["version_notes"])
        pulumi.export("versionNotes", version_notes_app_sec_version_nodes.output_text)
        ```

        :param str resource_name: The name of the resource.
        :param AppSecVersionNodesArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(AppSecVersionNodesArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 config_id: Optional[pulumi.Input[int]] = None,
                 version: Optional[pulumi.Input[int]] = None,
                 version_notes: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = AppSecVersionNodesArgs.__new__(AppSecVersionNodesArgs)

            if config_id is None and not opts.urn:
                raise TypeError("Missing required property 'config_id'")
            __props__.__dict__["config_id"] = config_id
            if version is None and not opts.urn:
                raise TypeError("Missing required property 'version'")
            __props__.__dict__["version"] = version
            if version_notes is None and not opts.urn:
                raise TypeError("Missing required property 'version_notes'")
            __props__.__dict__["version_notes"] = version_notes
            __props__.__dict__["output_text"] = None
        super(AppSecVersionNodes, __self__).__init__(
            'akamai:index/appSecVersionNodes:AppSecVersionNodes',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            config_id: Optional[pulumi.Input[int]] = None,
            output_text: Optional[pulumi.Input[str]] = None,
            version: Optional[pulumi.Input[int]] = None,
            version_notes: Optional[pulumi.Input[str]] = None) -> 'AppSecVersionNodes':
        """
        Get an existing AppSecVersionNodes resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[int] config_id: The configuration ID to use.
        :param pulumi.Input[str] output_text: A tabular display showing the updated version notes.
        :param pulumi.Input[int] version: The version number of the configuration to use.
        :param pulumi.Input[str] version_notes: A string containing the version notes to be used.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _AppSecVersionNodesState.__new__(_AppSecVersionNodesState)

        __props__.__dict__["config_id"] = config_id
        __props__.__dict__["output_text"] = output_text
        __props__.__dict__["version"] = version
        __props__.__dict__["version_notes"] = version_notes
        return AppSecVersionNodes(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="configId")
    def config_id(self) -> pulumi.Output[int]:
        """
        The configuration ID to use.
        """
        return pulumi.get(self, "config_id")

    @property
    @pulumi.getter(name="outputText")
    def output_text(self) -> pulumi.Output[str]:
        """
        A tabular display showing the updated version notes.
        """
        return pulumi.get(self, "output_text")

    @property
    @pulumi.getter
    def version(self) -> pulumi.Output[int]:
        """
        The version number of the configuration to use.
        """
        return pulumi.get(self, "version")

    @property
    @pulumi.getter(name="versionNotes")
    def version_notes(self) -> pulumi.Output[str]:
        """
        A string containing the version notes to be used.
        """
        return pulumi.get(self, "version_notes")

