# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'GetAppSecApiEndpointsResult',
    'AwaitableGetAppSecApiEndpointsResult',
    'get_app_sec_api_endpoints',
]

@pulumi.output_type
class GetAppSecApiEndpointsResult:
    """
    A collection of values returned by getAppSecApiEndpoints.
    """
    def __init__(__self__, api_name=None, config_id=None, id=None, id_lists=None, json=None, output_text=None, security_policy_id=None, version=None):
        if api_name and not isinstance(api_name, str):
            raise TypeError("Expected argument 'api_name' to be a str")
        pulumi.set(__self__, "api_name", api_name)
        if config_id and not isinstance(config_id, int):
            raise TypeError("Expected argument 'config_id' to be a int")
        pulumi.set(__self__, "config_id", config_id)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if id_lists and not isinstance(id_lists, list):
            raise TypeError("Expected argument 'id_lists' to be a list")
        pulumi.set(__self__, "id_lists", id_lists)
        if json and not isinstance(json, str):
            raise TypeError("Expected argument 'json' to be a str")
        pulumi.set(__self__, "json", json)
        if output_text and not isinstance(output_text, str):
            raise TypeError("Expected argument 'output_text' to be a str")
        pulumi.set(__self__, "output_text", output_text)
        if security_policy_id and not isinstance(security_policy_id, str):
            raise TypeError("Expected argument 'security_policy_id' to be a str")
        pulumi.set(__self__, "security_policy_id", security_policy_id)
        if version and not isinstance(version, int):
            raise TypeError("Expected argument 'version' to be a int")
        pulumi.set(__self__, "version", version)

    @property
    @pulumi.getter(name="apiName")
    def api_name(self) -> Optional[str]:
        return pulumi.get(self, "api_name")

    @property
    @pulumi.getter(name="configId")
    def config_id(self) -> int:
        return pulumi.get(self, "config_id")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="idLists")
    def id_lists(self) -> Sequence[int]:
        """
        A list of IDs of the API endpoints.
        """
        return pulumi.get(self, "id_lists")

    @property
    @pulumi.getter
    def json(self) -> str:
        """
        A JSON-formatted list of information about the API endpoints.
        """
        return pulumi.get(self, "json")

    @property
    @pulumi.getter(name="outputText")
    def output_text(self) -> str:
        """
        A tabular display showing the ID and name of the API endpoints.
        """
        return pulumi.get(self, "output_text")

    @property
    @pulumi.getter(name="securityPolicyId")
    def security_policy_id(self) -> Optional[str]:
        return pulumi.get(self, "security_policy_id")

    @property
    @pulumi.getter
    def version(self) -> int:
        return pulumi.get(self, "version")


class AwaitableGetAppSecApiEndpointsResult(GetAppSecApiEndpointsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetAppSecApiEndpointsResult(
            api_name=self.api_name,
            config_id=self.config_id,
            id=self.id,
            id_lists=self.id_lists,
            json=self.json,
            output_text=self.output_text,
            security_policy_id=self.security_policy_id,
            version=self.version)


def get_app_sec_api_endpoints(api_name: Optional[str] = None,
                              config_id: Optional[int] = None,
                              security_policy_id: Optional[str] = None,
                              version: Optional[int] = None,
                              opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetAppSecApiEndpointsResult:
    """
    Use the `getAppSecApiEndpoints` data source to retrieve information about the API Endpoints associated with a security policy or configuration version. The information available is described [here](https://developer.akamai.com/api/cloud_security/application_security/v1.html#getapiendpoints).

    ## Example Usage

    Basic usage:

    ```python
    import pulumi
    import pulumi_akamai as akamai

    api_endpoints = akamai.get_app_sec_api_endpoints(api_name="TestEndpoint",
        config_id=43253,
        version=7)
    ```


    :param str api_name: The name of a specific endpoint.
    :param int config_id: The configuration ID.
    :param str security_policy_id: The ID of the security policy to use.
    :param int version: The version number of the configuration.
    """
    __args__ = dict()
    __args__['apiName'] = api_name
    __args__['configId'] = config_id
    __args__['securityPolicyId'] = security_policy_id
    __args__['version'] = version
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
    __ret__ = pulumi.runtime.invoke('akamai:index/getAppSecApiEndpoints:getAppSecApiEndpoints', __args__, opts=opts, typ=GetAppSecApiEndpointsResult).value

    return AwaitableGetAppSecApiEndpointsResult(
        api_name=__ret__.api_name,
        config_id=__ret__.config_id,
        id=__ret__.id,
        id_lists=__ret__.id_lists,
        json=__ret__.json,
        output_text=__ret__.output_text,
        security_policy_id=__ret__.security_policy_id,
        version=__ret__.version)
