# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'GetAppSecCustomDenyResult',
    'AwaitableGetAppSecCustomDenyResult',
    'get_app_sec_custom_deny',
]

@pulumi.output_type
class GetAppSecCustomDenyResult:
    """
    A collection of values returned by getAppSecCustomDeny.
    """
    def __init__(__self__, config_id=None, custom_deny_id=None, id=None, json=None, output_text=None, version=None):
        if config_id and not isinstance(config_id, int):
            raise TypeError("Expected argument 'config_id' to be a int")
        pulumi.set(__self__, "config_id", config_id)
        if custom_deny_id and not isinstance(custom_deny_id, str):
            raise TypeError("Expected argument 'custom_deny_id' to be a str")
        pulumi.set(__self__, "custom_deny_id", custom_deny_id)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if json and not isinstance(json, str):
            raise TypeError("Expected argument 'json' to be a str")
        pulumi.set(__self__, "json", json)
        if output_text and not isinstance(output_text, str):
            raise TypeError("Expected argument 'output_text' to be a str")
        pulumi.set(__self__, "output_text", output_text)
        if version and not isinstance(version, int):
            raise TypeError("Expected argument 'version' to be a int")
        pulumi.set(__self__, "version", version)

    @property
    @pulumi.getter(name="configId")
    def config_id(self) -> int:
        return pulumi.get(self, "config_id")

    @property
    @pulumi.getter(name="customDenyId")
    def custom_deny_id(self) -> Optional[str]:
        return pulumi.get(self, "custom_deny_id")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def json(self) -> str:
        """
        A JSON-formatted list of the custom deny action information.
        """
        return pulumi.get(self, "json")

    @property
    @pulumi.getter(name="outputText")
    def output_text(self) -> str:
        """
        A tabular display showing the custom deny action information.
        """
        return pulumi.get(self, "output_text")

    @property
    @pulumi.getter
    def version(self) -> int:
        return pulumi.get(self, "version")


class AwaitableGetAppSecCustomDenyResult(GetAppSecCustomDenyResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetAppSecCustomDenyResult(
            config_id=self.config_id,
            custom_deny_id=self.custom_deny_id,
            id=self.id,
            json=self.json,
            output_text=self.output_text,
            version=self.version)


def get_app_sec_custom_deny(config_id: Optional[int] = None,
                            custom_deny_id: Optional[str] = None,
                            version: Optional[int] = None,
                            opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetAppSecCustomDenyResult:
    """
    Use the `AppSecCustomDeny` data source to retrieve information about custom deny actions for a specific security configuration version, or about a particular custom deny action. The information available is described [here](https://developer.akamai.com/api/cloud_security/application_security/v1.html#getcustomdeny).

    ## Example Usage

    Basic usage:

    ```python
    import pulumi
    import pulumi_akamai as akamai

    configuration = akamai.get_app_sec_configuration(name=var["security_configuration"])
    custom_deny_list = akamai.get_app_sec_custom_deny(config_id=configuration.config_id,
        version=configuration.latest_version)
    pulumi.export("customDenyListOutput", custom_deny_list.output_text)
    pulumi.export("customDenyListJson", custom_deny_list.json)
    custom_deny = akamai.get_app_sec_custom_deny(config_id=configuration.config_id,
        version=configuration.latest_version,
        custom_deny_id=var["custom_deny_id"])
    pulumi.export("customDenyJson", custom_deny.json)
    pulumi.export("customDenyOutput", custom_deny.output_text)
    ```


    :param int config_id: The configuration ID to use.
    :param str custom_deny_id: The ID of a specific custom deny action.
    :param int version: The version number of the configuration to use.
    """
    __args__ = dict()
    __args__['configId'] = config_id
    __args__['customDenyId'] = custom_deny_id
    __args__['version'] = version
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
    __ret__ = pulumi.runtime.invoke('akamai:index/getAppSecCustomDeny:getAppSecCustomDeny', __args__, opts=opts, typ=GetAppSecCustomDenyResult).value

    return AwaitableGetAppSecCustomDenyResult(
        config_id=__ret__.config_id,
        custom_deny_id=__ret__.custom_deny_id,
        id=__ret__.id,
        json=__ret__.json,
        output_text=__ret__.output_text,
        version=__ret__.version)
