# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'GetAppSecHostnameCoverageMatchTargetsResult',
    'AwaitableGetAppSecHostnameCoverageMatchTargetsResult',
    'get_app_sec_hostname_coverage_match_targets',
]

@pulumi.output_type
class GetAppSecHostnameCoverageMatchTargetsResult:
    """
    A collection of values returned by getAppSecHostnameCoverageMatchTargets.
    """
    def __init__(__self__, config_id=None, hostname=None, id=None, json=None, output_text=None, version=None):
        if config_id and not isinstance(config_id, int):
            raise TypeError("Expected argument 'config_id' to be a int")
        pulumi.set(__self__, "config_id", config_id)
        if hostname and not isinstance(hostname, str):
            raise TypeError("Expected argument 'hostname' to be a str")
        pulumi.set(__self__, "hostname", hostname)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if json and not isinstance(json, str):
            raise TypeError("Expected argument 'json' to be a str")
        pulumi.set(__self__, "json", json)
        if output_text and not isinstance(output_text, str):
            raise TypeError("Expected argument 'output_text' to be a str")
        pulumi.set(__self__, "output_text", output_text)
        if version and not isinstance(version, int):
            raise TypeError("Expected argument 'version' to be a int")
        pulumi.set(__self__, "version", version)

    @property
    @pulumi.getter(name="configId")
    def config_id(self) -> int:
        return pulumi.get(self, "config_id")

    @property
    @pulumi.getter
    def hostname(self) -> str:
        return pulumi.get(self, "hostname")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def json(self) -> str:
        """
        A JSON-formatted list of the coverage information.
        """
        return pulumi.get(self, "json")

    @property
    @pulumi.getter(name="outputText")
    def output_text(self) -> str:
        """
        A tabular display of the coverage information.
        """
        return pulumi.get(self, "output_text")

    @property
    @pulumi.getter
    def version(self) -> int:
        return pulumi.get(self, "version")


class AwaitableGetAppSecHostnameCoverageMatchTargetsResult(GetAppSecHostnameCoverageMatchTargetsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetAppSecHostnameCoverageMatchTargetsResult(
            config_id=self.config_id,
            hostname=self.hostname,
            id=self.id,
            json=self.json,
            output_text=self.output_text,
            version=self.version)


def get_app_sec_hostname_coverage_match_targets(config_id: Optional[int] = None,
                                                hostname: Optional[str] = None,
                                                version: Optional[int] = None,
                                                opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetAppSecHostnameCoverageMatchTargetsResult:
    """
    Use the `getAppSecHostnameCoverageMatchTargets` data source to retrieve information about the API and website match targets that protect a hostname. The information available is described [here](https://developer.akamai.com/api/cloud_security/application_security/v1.html#gethostnamecoveragematchtargets).

    ## Example Usage

    Basic usage:

    ```python
    import pulumi
    import pulumi_akamai as akamai

    match_targets = akamai.get_app_sec_hostname_coverage_match_targets(config_id=43253,
        hostname="example.com",
        version=7)
    ```


    :param int config_id: The configuration ID.
    :param str hostname: The hostname for which to retrieve information.
    :param int version: The version number of the configuration.
    """
    __args__ = dict()
    __args__['configId'] = config_id
    __args__['hostname'] = hostname
    __args__['version'] = version
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
    __ret__ = pulumi.runtime.invoke('akamai:index/getAppSecHostnameCoverageMatchTargets:getAppSecHostnameCoverageMatchTargets', __args__, opts=opts, typ=GetAppSecHostnameCoverageMatchTargetsResult).value

    return AwaitableGetAppSecHostnameCoverageMatchTargetsResult(
        config_id=__ret__.config_id,
        hostname=__ret__.hostname,
        id=__ret__.id,
        json=__ret__.json,
        output_text=__ret__.output_text,
        version=__ret__.version)
