# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'GetAppSecRatePolicyActionsResult',
    'AwaitableGetAppSecRatePolicyActionsResult',
    'get_app_sec_rate_policy_actions',
]

@pulumi.output_type
class GetAppSecRatePolicyActionsResult:
    """
    A collection of values returned by getAppSecRatePolicyActions.
    """
    def __init__(__self__, config_id=None, id=None, output_text=None, rate_policy_id=None, security_policy_id=None, version=None):
        if config_id and not isinstance(config_id, int):
            raise TypeError("Expected argument 'config_id' to be a int")
        pulumi.set(__self__, "config_id", config_id)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if output_text and not isinstance(output_text, str):
            raise TypeError("Expected argument 'output_text' to be a str")
        pulumi.set(__self__, "output_text", output_text)
        if rate_policy_id and not isinstance(rate_policy_id, int):
            raise TypeError("Expected argument 'rate_policy_id' to be a int")
        pulumi.set(__self__, "rate_policy_id", rate_policy_id)
        if security_policy_id and not isinstance(security_policy_id, str):
            raise TypeError("Expected argument 'security_policy_id' to be a str")
        pulumi.set(__self__, "security_policy_id", security_policy_id)
        if version and not isinstance(version, int):
            raise TypeError("Expected argument 'version' to be a int")
        pulumi.set(__self__, "version", version)

    @property
    @pulumi.getter(name="configId")
    def config_id(self) -> int:
        return pulumi.get(self, "config_id")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="outputText")
    def output_text(self) -> str:
        """
        A tabular display showing the ID IPv4Action and IPv6Action of the indicated security policy.
        """
        return pulumi.get(self, "output_text")

    @property
    @pulumi.getter(name="ratePolicyId")
    def rate_policy_id(self) -> Optional[int]:
        return pulumi.get(self, "rate_policy_id")

    @property
    @pulumi.getter(name="securityPolicyId")
    def security_policy_id(self) -> str:
        return pulumi.get(self, "security_policy_id")

    @property
    @pulumi.getter
    def version(self) -> int:
        return pulumi.get(self, "version")


class AwaitableGetAppSecRatePolicyActionsResult(GetAppSecRatePolicyActionsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetAppSecRatePolicyActionsResult(
            config_id=self.config_id,
            id=self.id,
            output_text=self.output_text,
            rate_policy_id=self.rate_policy_id,
            security_policy_id=self.security_policy_id,
            version=self.version)


def get_app_sec_rate_policy_actions(config_id: Optional[int] = None,
                                    rate_policy_id: Optional[int] = None,
                                    security_policy_id: Optional[str] = None,
                                    version: Optional[int] = None,
                                    opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetAppSecRatePolicyActionsResult:
    """
    Use the `getAppSecRatePolicyActions` data source to retrieve a list of all rate policies associated with a given configuration version and security policy, or the actions associated with a specific rate policy.

    ## Example Usage

    Basic usage:

    ```python
    import pulumi
    import pulumi_akamai as akamai

    configuration = akamai.get_app_sec_configuration(name=var["security_configuration"])
    rate_policy_actions_app_sec_rate_policy_actions = akamai.get_app_sec_rate_policy_actions(config_id=configuration.config_id,
        version=configuration.latest_version,
        security_policy_id=var["security_policy_id"])
    pulumi.export("ratePolicyActions", rate_policy_actions_app_sec_rate_policy_actions.output_text)
    ```


    :param int config_id: The ID of the security configuration to use.
    :param int rate_policy_id: The ID of the rate policy to use. If not supplied, information about all rate policies will be returned.
    :param str security_policy_id: The ID of the security policy to use.
    :param int version: The version number of the security configuration to use.
    """
    __args__ = dict()
    __args__['configId'] = config_id
    __args__['ratePolicyId'] = rate_policy_id
    __args__['securityPolicyId'] = security_policy_id
    __args__['version'] = version
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
    __ret__ = pulumi.runtime.invoke('akamai:index/getAppSecRatePolicyActions:getAppSecRatePolicyActions', __args__, opts=opts, typ=GetAppSecRatePolicyActionsResult).value

    return AwaitableGetAppSecRatePolicyActionsResult(
        config_id=__ret__.config_id,
        id=__ret__.id,
        output_text=__ret__.output_text,
        rate_policy_id=__ret__.rate_policy_id,
        security_policy_id=__ret__.security_policy_id,
        version=__ret__.version)
