# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['PropertyVariablesArgs', 'PropertyVariables']

@pulumi.input_type
class PropertyVariablesArgs:
    def __init__(__self__, *,
                 variables: Optional[pulumi.Input[Sequence[pulumi.Input['PropertyVariablesVariableArgs']]]] = None):
        """
        The set of arguments for constructing a PropertyVariables resource.
        """
        if variables is not None:
            warnings.warn("""The setting \"akamai_property_variables\" has been deprecated.""", DeprecationWarning)
            pulumi.log.warn("""variables is deprecated: The setting \"akamai_property_variables\" has been deprecated.""")
        if variables is not None:
            pulumi.set(__self__, "variables", variables)

    @property
    @pulumi.getter
    def variables(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['PropertyVariablesVariableArgs']]]]:
        return pulumi.get(self, "variables")

    @variables.setter
    def variables(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['PropertyVariablesVariableArgs']]]]):
        pulumi.set(self, "variables", value)


@pulumi.input_type
class _PropertyVariablesState:
    def __init__(__self__, *,
                 json: Optional[pulumi.Input[str]] = None,
                 variables: Optional[pulumi.Input[Sequence[pulumi.Input['PropertyVariablesVariableArgs']]]] = None):
        """
        Input properties used for looking up and filtering PropertyVariables resources.
        :param pulumi.Input[str] json: JSON variables representation
        """
        if json is not None:
            pulumi.set(__self__, "json", json)
        if variables is not None:
            warnings.warn("""The setting \"akamai_property_variables\" has been deprecated.""", DeprecationWarning)
            pulumi.log.warn("""variables is deprecated: The setting \"akamai_property_variables\" has been deprecated.""")
        if variables is not None:
            pulumi.set(__self__, "variables", variables)

    @property
    @pulumi.getter
    def json(self) -> Optional[pulumi.Input[str]]:
        """
        JSON variables representation
        """
        return pulumi.get(self, "json")

    @json.setter
    def json(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "json", value)

    @property
    @pulumi.getter
    def variables(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['PropertyVariablesVariableArgs']]]]:
        return pulumi.get(self, "variables")

    @variables.setter
    def variables(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['PropertyVariablesVariableArgs']]]]):
        pulumi.set(self, "variables", value)


class PropertyVariables(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 variables: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['PropertyVariablesVariableArgs']]]]] = None,
                 __props__=None):
        """
        Create a PropertyVariables resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: Optional[PropertyVariablesArgs] = None,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a PropertyVariables resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param PropertyVariablesArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(PropertyVariablesArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 variables: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['PropertyVariablesVariableArgs']]]]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = PropertyVariablesArgs.__new__(PropertyVariablesArgs)

            if variables is not None and not opts.urn:
                warnings.warn("""The setting \"akamai_property_variables\" has been deprecated.""", DeprecationWarning)
                pulumi.log.warn("""variables is deprecated: The setting \"akamai_property_variables\" has been deprecated.""")
            __props__.__dict__["variables"] = variables
            __props__.__dict__["json"] = None
        alias_opts = pulumi.ResourceOptions(aliases=[pulumi.Alias(type_="akamai:properties/propertyVariables:PropertyVariables")])
        opts = pulumi.ResourceOptions.merge(opts, alias_opts)
        super(PropertyVariables, __self__).__init__(
            'akamai:index/propertyVariables:PropertyVariables',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            json: Optional[pulumi.Input[str]] = None,
            variables: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['PropertyVariablesVariableArgs']]]]] = None) -> 'PropertyVariables':
        """
        Get an existing PropertyVariables resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] json: JSON variables representation
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _PropertyVariablesState.__new__(_PropertyVariablesState)

        __props__.__dict__["json"] = json
        __props__.__dict__["variables"] = variables
        return PropertyVariables(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def json(self) -> pulumi.Output[str]:
        """
        JSON variables representation
        """
        return pulumi.get(self, "json")

    @property
    @pulumi.getter
    def variables(self) -> pulumi.Output[Optional[Sequence['outputs.PropertyVariablesVariable']]]:
        return pulumi.get(self, "variables")

